#include "stm32f10x_conf.h" // with #define USE_STDPERIPH_DRIVER 1
#include "delay.h"
//#include "OWire.h"
//#include "ds18x20.h"
#include <stdio.h>

// ********* 64pin LQFP Package *******
// PIN03: **availabe**
// PIN04: **availabe**
// PIN05: OSC 25Mhz
// PIN06: OSC 25Mhz
// PIN07: NRST
// PIN08: **availabe**
// PIN09: RMII
// PIN10: **availabe**
// PIN11: **availabe**
// PIN14: **availabe**
// PIN15: RMII
// PIN16: RMII
// PIN17: **availabe**
// PIN20: **availabe**
// PIN21: **availabe**
// PIN22: **availabe**
// PIN23: RMII
// PIN24: RMII
// PIN25: RMII
// PIN26: **availabe**
// PIN27: **availabe**
// PIN28: **availabe**
// PIN29: PB10 : LED
// PIN30: RMII
// PIN33: RMII
// PIN34: RMII
// PIN35: **availabe**
// PIN36: **availabe**
// PIN37: **availabe**
// PIN38: **availabe**
// PIN39: **availabe**
// PIN40: **availabe**
// PIN41: RMII: MCO 50Mhz out // USB_SOF ??
// PIN42: PA09 : USART1_TX USB_VBUS
// PIN43: PA10 : USART1_RX USB_ID
// PIN44: USB_DM
// PIN45: **availabe**
// PIN46: SWD
// PIN49: SWD
// PIN50: **reserved for lcd**
// PIN51: PC10 : DS18x20
// PIN52: **reserved for lcd**
// PIN53: **reserved for lcd**
// PIN54: **reserved for lcd**
// PIN55: **reserved for lcd**
// PIN56: **reserved for lcd**
// PIN57: **reserved for lcd**
// PIN58: PB6  : I2C1_SCL
// PIN59: PB7  : I2C1_SDA
// PIN60: BOOT0=GND
// PIN61: **availabe**
// PIN62: **availabe**

// Timer2: Toggle LED

/***************************************************************************//**
 * Declare function prototypes
 ******************************************************************************/
void RCC_Configuration(void);
void GPIO_Configuration(void);
void NVIC_Configuration(void);
void SetupClock(void);
void SetupUSART(void);
void SetupTimer(void);
void USART1_SendString(char* data);

// Global variables
#define MAXSENSORS 8
uint8_t gSensorIDs[MAXSENSORS][9]; // 9=size of ROM codes

// *************** main *************

int main(void) {
	char buffer[255];

	sprintf(buffer,"this is the default value\n");

	RCC_ClocksTypeDef RCC_Clocks;

	SystemInit();

	/* System Clocks Configuration */
	RCC_Configuration();

	/* NVIC configuration */
	//NVIC_Configuration();
	/* GPIO configuration */
	GPIO_Configuration();

	/* ADC configuration */
	//ADC_Configuration();

	SetupUSART();
	SetupTimer();
	delay_init();
	//DS18x20Init();

	USART1_SendString("\n\n*** START ***\n");

	RCC_GetClocksFreq(&RCC_Clocks);
	sprintf(buffer, "\nSYSCLK: %li \n", RCC_Clocks.SYSCLK_Frequency / 1000);
	USART1_SendString(buffer);
	//sprintf(buffer,"test, %i\n", 1000);
	//USART1_SendString(buffer);
	sprintf(buffer, "HCLK: %li \n", RCC_Clocks.HCLK_Frequency / 1000);
	USART1_SendString(buffer);
	sprintf(buffer, "PCLK1: %li \n", RCC_Clocks.PCLK1_Frequency / 1000);
	USART1_SendString(buffer);
	sprintf(buffer, "PCLK2: %li \n", RCC_Clocks.PCLK2_Frequency / 1000);
	USART1_SendString(buffer);

	//unsigned char DeviceAddress[8];
	//int nCount = 0;
	//int i;
	/*
	 float temperature;


	 FindDevices();                                                  // fonction cherchant le nombre de ds1820 et leur numero de serie


	 while (1)
	 {

	 if ( First() )
	 {
	 temperature =  DS1820_GetTemp();

	 sprintf(buffer,"\t temp = %f   \n",temperature);
	 USART1_SendString(buffer);
	 }
	 }
	 */
	/*

	 while(OWSearch(&OneWire, DeviceAddress))
	 {
	 sprintf(buffer,"Device %d: %02X %02X %02X %02X %02X %02X %02X %02X \n",
	 nCount+1,
	 DeviceAddress[7],DeviceAddress[6],
	 DeviceAddress[5],DeviceAddress[4],
	 DeviceAddress[3],DeviceAddress[2],
	 DeviceAddress[1],DeviceAddress[0]);
	 USART1_SendString(buffer);

	 for (i=0;i<8;i++)
	 gSensorsIDs[nCount][i]=DeviceAddress[i];

	 nCount++;

	 if (nCount>MAXSENSORS) break;
	 }

	 sprintf(buffer, "DeviceCount: %d\n",nCount);
	 USART1_SendString(buffer);

	 */

	while (1) {

		//GPIOB->ODR ^= GPIO_Pin_10;
		/* delay */
		//for(i=0;i<0x300000;i++);
		//USART1_SendString("in while\n\r");

	}
}

void USART1_SendString(char* data) {
	while (*data) {
		USART_SendData(USART1, (uint16_t) * data);
		while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET)
			;
		data++;
	}
	delay_ms(50);
}

void SetupTimer(void) {

	TIM_TimeBaseInitTypeDef TIM_TimeBase_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	uint16_t PrescalerValue;

	/* Enable TIM2 clock */
	//RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);  // sollten 36Mhz sein
	PrescalerValue = (uint16_t) 36000 - 1; // Vorteiler berechnen  (36Mhz/36000 = 1khz)
	TIM_TimeBase_InitStructure.TIM_Prescaler = PrescalerValue; //
	TIM_TimeBase_InitStructure.TIM_ClockDivision = TIM_CKD_DIV1; // nach Prescaler=1kHz
	TIM_TimeBase_InitStructure.TIM_CounterMode = TIM_CounterMode_Up;
	TIM_TimeBase_InitStructure.TIM_Period = 1000; // Eine Sekunde (=1000*1kHz=1s)

	TIM_TimeBaseInit(TIM2, &TIM_TimeBase_InitStructure);

	//Timer Vorteiler-Taktkonfiguration
//	TIM_PrescalerConfig(TIM2, PrescalerValue, TIM_PSCReloadMode_Immediate); // Auto-Reload

	// Timer Interruptkonfiguration
	TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE); // Interrupt bei berlauf

	TIM_ClearFlag(TIM2, TIM_FLAG_Update);

	// Enable and set TIM1 Interrupt to the lowest priority
	// Enable the TIM1 global Interrupt
	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x00;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x01;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	TIM_Cmd(TIM2, ENABLE);
	TIM_ClearITPendingBit(TIM2, TIM_IT_Update);

}

//timer 2 interrupt
extern void TIM2_IRQHandler(void) {

	//if interrupt happens the do this
	if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET) {
		//clear interrupt and start counting again to get precise freq
		TIM_ClearITPendingBit(TIM2, TIM_IT_Update);

		//toggle led
		GPIOB->ODR ^= GPIO_Pin_10;

	}

}

/***************************************************************************//**
 *  Setup GPIOs
 ******************************************************************************/
void GPIO_Configuration(void) {
	GPIO_InitTypeDef GPIO_InitStructure;

	/* Configure the GPIO_LED pin */
	GPIO_StructInit(&GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	/* MCO pin configuration------------------------------------------------- */
	/* Configure MCO (PA8) as alternate function push-pull */
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
	 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	 GPIO_Init(GPIOA, &GPIO_InitStructure);

}

/***************************************************************************//**
 * Setup clocks
 ******************************************************************************/
void RCC_Configuration(void) {

	ErrorStatus HSEStartUpStatus;
	RCC_ClocksTypeDef RCC_ClockFreq;

	//RCC_DeInit(); /* RCC system reset(for debug purpose)*/
	RCC_HSEConfig(RCC_HSE_ON); /* Enable HSE (external Quarz, 25Mhz)        */

	/* Wait till HSE is ready */
	HSEStartUpStatus = RCC_WaitForHSEStartUp();

	if (HSEStartUpStatus != ERROR) {
		/* Enable Prefetch Buffer */
		FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
	}

	/****************************************************************/
	/*      HSE=25MHz, HCLK=72MHz, PCLK2=72MHz, PCLK1=36MHz         */
	/****************************************************************/
	/* Flash 2 wait state */
	FLASH_SetLatency(FLASH_Latency_2);
	/* HCLK = SYSCLK */
	RCC_HCLKConfig(RCC_SYSCLK_Div1);
	/* PCLK2 = HCLK */
	RCC_PCLK2Config(RCC_HCLK_Div1);
	/* PCLK1 = HCLK/2 */
	RCC_PCLK1Config(RCC_HCLK_Div2);
	/*  ADCCLK = PCLK2/4 */
	RCC_ADCCLKConfig(RCC_PCLK2_Div6);

	/* Configure PLLs *********************************************************/
	/* PPL2 configuration: PLL2CLK = (HSE / 5) * 8 = 40 MHz */
	RCC_PREDIV2Config(RCC_PREDIV2_Div5);
	RCC_PLL2Config(RCC_PLL2Mul_8);

	/* Enable PLL2 */
	RCC_PLL2Cmd(ENABLE);

	/* Wait till PLL2 is ready */
	while (RCC_GetFlagStatus(RCC_FLAG_PLL2RDY) == RESET) {
	}



	/* PPL1 configuration: PLLCLK = (PLL2 / 5) * 9 = 72 MHz */
	RCC_PREDIV1Config(RCC_PREDIV1_Source_PLL2, RCC_PREDIV1_Div5);
	RCC_PLLConfig(RCC_PLLSource_PREDIV1, RCC_PLLMul_9);

	/* Enable PLL */
	RCC_PLLCmd(ENABLE);

	/* Wait till PLL is ready */
	while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET) {
	}

	/* Select PLL as system clock source */
	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

	/* Wait till PLL is used as system clock source */
	while (RCC_GetSYSCLKSource() != 0x08) {
	}

	RCC_GetClocksFreq(&RCC_ClockFreq);

	/* Enable USART1 clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);

	/* Enable ETHERNET clock  */
	RCC_AHBPeriphClockCmd(
			RCC_AHBPeriph_ETH_MAC | RCC_AHBPeriph_ETH_MAC_Tx |
					                RCC_AHBPeriph_ETH_MAC_Rx, ENABLE);

	// Enable GPIOs clocks
	RCC_APB2PeriphClockCmd(
			RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC, ENABLE);

	// Enable ADC1 clock
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);

	// Enable Timer-Clocks
	 RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);


	 // Get clock PLL3 clock on PA8 pin
	 RCC_MCOConfig(RCC_MCO_PLL3CLK);

}

/***************************************************************************//**
 * @brief Init USART1
 ******************************************************************************/
void SetupUSART() {
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;

	/* Enable GPIOA clock                                                   */
	//RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	/* Configure USART1 Rx (PA10) as input floating                         */
	GPIO_StructInit(&GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* Configure USART1 Tx (PA9) as alternate function push-pull            */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* USART1 configured as follow:
	 - BaudRate = 115200 baud
	 - Word Length = 8 Bits
	 - One Stop Bit
	 - No parity
	 - Hardware flow control disabled (RTS and CTS signals)
	 - Receive and transmit enabled
	 - USART Clock disabled
	 - USART CPOL: Clock is active low
	 - USART CPHA: Data is captured on the middle
	 - USART LastBit: The clock pulse of the last data bit is not output to
	 the SCLK pin
	 */
	USART_InitStructure.USART_BaudRate = 115200;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl =
			USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART1, &USART_InitStructure);
	USART_Cmd(USART1, ENABLE);
}
